<?php

namespace xt_soapapi\xt_soapapi-php\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEtatStock ArrayType
 * @subpackage Arrays
 */
class ArrayOfEtatStock extends AbstractStructArrayBase
{
    /**
     * The EtatStock
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \xt_soapapi\xt_soapapi-php\StructType\EtatStock[]
     */
    public $EtatStock;
    /**
     * Constructor method for ArrayOfEtatStock
     * @uses ArrayOfEtatStock::setEtatStock()
     * @param \xt_soapapi\xt_soapapi-php\StructType\EtatStock[] $etatStock
     */
    public function __construct(array $etatStock = array())
    {
        $this
            ->setEtatStock($etatStock);
    }
    /**
     * Get EtatStock value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \xt_soapapi\xt_soapapi-php\StructType\EtatStock[]|null
     */
    public function getEtatStock()
    {
        return isset($this->EtatStock) ? $this->EtatStock : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEtatStock method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEtatStock method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEtatStockForArrayConstraintsFromSetEtatStock(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEtatStockEtatStockItem) {
            // validation for constraint: itemType
            if (!$arrayOfEtatStockEtatStockItem instanceof \xt_soapapi\xt_soapapi-php\StructType\EtatStock) {
                $invalidValues[] = is_object($arrayOfEtatStockEtatStockItem) ? get_class($arrayOfEtatStockEtatStockItem) : sprintf('%s(%s)', gettype($arrayOfEtatStockEtatStockItem), var_export($arrayOfEtatStockEtatStockItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EtatStock property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\EtatStock, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EtatStock value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\EtatStock[] $etatStock
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfEtatStock
     */
    public function setEtatStock(array $etatStock = array())
    {
        // validation for constraint: array
        if ('' !== ($etatStockArrayErrorMessage = self::validateEtatStockForArrayConstraintsFromSetEtatStock($etatStock))) {
            throw new \InvalidArgumentException($etatStockArrayErrorMessage, __LINE__);
        }
        if (is_null($etatStock) || (is_array($etatStock) && empty($etatStock))) {
            unset($this->EtatStock);
        } else {
            $this->EtatStock = $etatStock;
        }
        return $this;
    }
    /**
     * Add item to EtatStock value
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\EtatStock $item
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfEtatStock
     */
    public function addToEtatStock(\xt_soapapi\xt_soapapi-php\StructType\EtatStock $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \xt_soapapi\xt_soapapi-php\StructType\EtatStock) {
            throw new \InvalidArgumentException(sprintf('The EtatStock property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\EtatStock, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EtatStock[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \xt_soapapi\xt_soapapi-php\StructType\EtatStock|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \xt_soapapi\xt_soapapi-php\StructType\EtatStock|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \xt_soapapi\xt_soapapi-php\StructType\EtatStock|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \xt_soapapi\xt_soapapi-php\StructType\EtatStock|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \xt_soapapi\xt_soapapi-php\StructType\EtatStock|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EtatStock
     */
    public function getAttributeName()
    {
        return 'EtatStock';
    }
}
