<?php

namespace xt_soapapi\xt_soapapi-php\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLigneCommande ArrayType
 * @subpackage Arrays
 */
class ArrayOfLigneCommande extends AbstractStructArrayBase
{
    /**
     * The LigneCommande
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \xt_soapapi\xt_soapapi-php\StructType\LigneCommande[]
     */
    public $LigneCommande;
    /**
     * Constructor method for ArrayOfLigneCommande
     * @uses ArrayOfLigneCommande::setLigneCommande()
     * @param \xt_soapapi\xt_soapapi-php\StructType\LigneCommande[] $ligneCommande
     */
    public function __construct(array $ligneCommande = array())
    {
        $this
            ->setLigneCommande($ligneCommande);
    }
    /**
     * Get LigneCommande value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande[]|null
     */
    public function getLigneCommande()
    {
        return isset($this->LigneCommande) ? $this->LigneCommande : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLigneCommande method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLigneCommande method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLigneCommandeForArrayConstraintsFromSetLigneCommande(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLigneCommandeLigneCommandeItem) {
            // validation for constraint: itemType
            if (!$arrayOfLigneCommandeLigneCommandeItem instanceof \xt_soapapi\xt_soapapi-php\StructType\LigneCommande) {
                $invalidValues[] = is_object($arrayOfLigneCommandeLigneCommandeItem) ? get_class($arrayOfLigneCommandeLigneCommandeItem) : sprintf('%s(%s)', gettype($arrayOfLigneCommandeLigneCommandeItem), var_export($arrayOfLigneCommandeLigneCommandeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LigneCommande property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\LigneCommande, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LigneCommande value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\LigneCommande[] $ligneCommande
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfLigneCommande
     */
    public function setLigneCommande(array $ligneCommande = array())
    {
        // validation for constraint: array
        if ('' !== ($ligneCommandeArrayErrorMessage = self::validateLigneCommandeForArrayConstraintsFromSetLigneCommande($ligneCommande))) {
            throw new \InvalidArgumentException($ligneCommandeArrayErrorMessage, __LINE__);
        }
        if (is_null($ligneCommande) || (is_array($ligneCommande) && empty($ligneCommande))) {
            unset($this->LigneCommande);
        } else {
            $this->LigneCommande = $ligneCommande;
        }
        return $this;
    }
    /**
     * Add item to LigneCommande value
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\LigneCommande $item
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfLigneCommande
     */
    public function addToLigneCommande(\xt_soapapi\xt_soapapi-php\StructType\LigneCommande $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \xt_soapapi\xt_soapapi-php\StructType\LigneCommande) {
            throw new \InvalidArgumentException(sprintf('The LigneCommande property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\LigneCommande, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LigneCommande[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LigneCommande
     */
    public function getAttributeName()
    {
        return 'LigneCommande';
    }
}
