<?php

namespace xt_soapapi\xt_soapapi-php\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLigneReglement ArrayType
 * @subpackage Arrays
 */
class ArrayOfLigneReglement extends AbstractStructArrayBase
{
    /**
     * The LigneReglement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \xt_soapapi\xt_soapapi-php\StructType\LigneReglement[]
     */
    public $LigneReglement;
    /**
     * Constructor method for ArrayOfLigneReglement
     * @uses ArrayOfLigneReglement::setLigneReglement()
     * @param \xt_soapapi\xt_soapapi-php\StructType\LigneReglement[] $ligneReglement
     */
    public function __construct(array $ligneReglement = array())
    {
        $this
            ->setLigneReglement($ligneReglement);
    }
    /**
     * Get LigneReglement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneReglement[]|null
     */
    public function getLigneReglement()
    {
        return isset($this->LigneReglement) ? $this->LigneReglement : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLigneReglement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLigneReglement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLigneReglementForArrayConstraintsFromSetLigneReglement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLigneReglementLigneReglementItem) {
            // validation for constraint: itemType
            if (!$arrayOfLigneReglementLigneReglementItem instanceof \xt_soapapi\xt_soapapi-php\StructType\LigneReglement) {
                $invalidValues[] = is_object($arrayOfLigneReglementLigneReglementItem) ? get_class($arrayOfLigneReglementLigneReglementItem) : sprintf('%s(%s)', gettype($arrayOfLigneReglementLigneReglementItem), var_export($arrayOfLigneReglementLigneReglementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LigneReglement property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\LigneReglement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LigneReglement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\LigneReglement[] $ligneReglement
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfLigneReglement
     */
    public function setLigneReglement(array $ligneReglement = array())
    {
        // validation for constraint: array
        if ('' !== ($ligneReglementArrayErrorMessage = self::validateLigneReglementForArrayConstraintsFromSetLigneReglement($ligneReglement))) {
            throw new \InvalidArgumentException($ligneReglementArrayErrorMessage, __LINE__);
        }
        if (is_null($ligneReglement) || (is_array($ligneReglement) && empty($ligneReglement))) {
            unset($this->LigneReglement);
        } else {
            $this->LigneReglement = $ligneReglement;
        }
        return $this;
    }
    /**
     * Add item to LigneReglement value
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\LigneReglement $item
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfLigneReglement
     */
    public function addToLigneReglement(\xt_soapapi\xt_soapapi-php\StructType\LigneReglement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \xt_soapapi\xt_soapapi-php\StructType\LigneReglement) {
            throw new \InvalidArgumentException(sprintf('The LigneReglement property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\LigneReglement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LigneReglement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneReglement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneReglement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneReglement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneReglement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneReglement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LigneReglement
     */
    public function getAttributeName()
    {
        return 'LigneReglement';
    }
}
